diff --git a/helper/include/odp/helper/odph_cuckootable.h b/helper/include/odp/helper/odph_cuckootable.h
index d569980..65cd555 100644
--- a/helper/include/odp/helper/odph_cuckootable.h
+++ b/helper/include/odp/helper/odph_cuckootable.h
@@ -52,27 +52,79 @@
 extern "C" {
 #endif
 
+/**
+ * documentation missing
+ *
+ * @param name
+ * @param capacity
+ * @param key_size
+ * @param value_size
+ *
+ * @return
+ */
 odph_table_t odph_cuckoo_table_create(
 		const char *name,
 		uint32_t capacity,
 		uint32_t key_size,
 		uint32_t value_size);
 
+/**
+ * documentation missing
+ *
+ * @param name
+ *
+ * @return
+ */
 odph_table_t odph_cuckoo_table_lookup(const char *name);
 
+/**
+ * documentation missing
+ *
+ * @param table
+ *
+ * @return
+ */
 int odph_cuckoo_table_destroy(odph_table_t table);
 
+/**
+ * documentation missing
+ *
+ * @param table
+ * @param key
+ * @param value
+ *
+ * @return
+ */
 int odph_cuckoo_table_put_value(
 		odph_table_t table,
 		void *key, void *value);
 
+/**
+ * documentation missing
+ *
+ * @param table
+ * @param key
+ * @param buffer
+ * @param buffer_size
+ *
+ * @return
+ */
 int odph_cuckoo_table_get_value(
 		odph_table_t table,
 		void *key, void *buffer,
 		uint32_t buffer_size);
 
+/**
+ * documentation missing
+ *
+ * @param table
+ * @param key
+ *
+ * @return
+ */
 int odph_cuckoo_table_remove_value(odph_table_t table, void *key);
 
+/** documentation missing */
 extern odph_table_ops_t odph_cuckoo_table_ops;
 
 #ifdef __cplusplus
diff --git a/helper/include/odp/helper/odph_hashtable.h b/helper/include/odp/helper/odph_hashtable.h
index bb75cb9..d3dce99 100644
--- a/helper/include/odp/helper/odph_hashtable.h
+++ b/helper/include/odp/helper/odph_hashtable.h
@@ -19,17 +19,74 @@
 extern "C" {
 #endif
 
+/**
+ * documentation missing
+ *
+ * @param name
+ * @param capacity
+ * @param key_size
+ * @param value_size
+ *
+ * @return
+ */
 odph_table_t odph_hash_table_create(const char *name,
 				    uint32_t capacity,
 				    uint32_t key_size,
 				    uint32_t value_size);
+
+/**
+ * documentation missing
+ *
+ * @param name
+ *
+ * @return
+ */
 odph_table_t odph_hash_table_lookup(const char *name);
+
+/**
+ * documentation missing
+ *
+ * @param table
+ *
+ * @return
+ */
 int odph_hash_table_destroy(odph_table_t table);
+
+/**
+ * documentation missing
+ *
+ * @param table
+ * @param key
+ * @param value
+ *
+ * @return
+ */
 int odph_hash_put_value(odph_table_t table, void *key, void *value);
+
+/**
+ * documentation missing
+ *
+ * @param table
+ * @param key
+ * @param buffer
+ * @param buffer_size
+ *
+ * @return
+ */
 int odph_hash_get_value(odph_table_t table, void *key, void *buffer,
 			uint32_t buffer_size);
+
+/**
+ * documentation missing
+ *
+ * @param table
+ * @param key
+ *
+ * @return
+ */
 int odph_hash_remove_value(odph_table_t table, void *key);
 
+/** documentation missing */
 extern odph_table_ops_t odph_hash_table_ops;
 
 #ifdef __cplusplus
diff --git a/helper/include/odp/helper/odph_iplookuptable.h b/helper/include/odp/helper/odph_iplookuptable.h
index 0ae6b37..f5da493 100644
--- a/helper/include/odp/helper/odph_iplookuptable.h
+++ b/helper/include/odp/helper/odph_iplookuptable.h
@@ -24,31 +24,84 @@
 extern "C" {
 #endif
 
+/** documentation missing */
 typedef struct {
-	uint32_t ip;
-	uint8_t cidr;
+	uint32_t ip;  /**< IP */
+	uint8_t cidr; /**< CIDR */
 } odph_iplookup_prefix_t;
 
+/**
+ * documentation missing
+ *
+ * @param name
+ * @param ODP_IGNORED_1
+ * @param ODP_IGNORED_2
+ * @param value_size
+ *
+ * @return
+ */
 odph_table_t odph_iplookup_table_create(
 		const char *name,
 		uint32_t ODP_IGNORED_1,
 		uint32_t ODP_IGNORED_2,
 		uint32_t value_size);
 
+/**
+ * documentation missing
+ *
+ * @param name
+ *
+ * @return
+ */
 odph_table_t odph_iplookup_table_lookup(const char *name);
 
+/**
+ * documentation missing
+ *
+ * @param table
+ *
+ * @return
+ */
 int odph_iplookup_table_destroy(odph_table_t table);
 
+/**
+ * documentation missing
+ *
+ * @param table
+ * @param key
+ * @param value
+ *
+ * @return
+ */
 int odph_iplookup_table_put_value(
 		odph_table_t table, void *key, void *value);
 
+/**
+ * documentation missing
+ *
+ * @param table
+ * @param key
+ * @param buffer
+ * @param buffer_size
+ *
+ * @return
+ */
 int odph_iplookup_table_get_value(
 		odph_table_t table, void *key,
 		void *buffer, uint32_t buffer_size);
 
+/**
+ * documentation missing
+ *
+ * @param table
+ * @param key
+ *
+ * @return
+ */
 int odph_iplookup_table_remove_value(
 		odph_table_t table, void *key);
 
+/** documentation missing */
 extern odph_table_ops_t odph_iplookup_table_ops;
 
 #ifdef __cplusplus
diff --git a/helper/include/odp/helper/odph_lineartable.h b/helper/include/odp/helper/odph_lineartable.h
index 0b56b7f..c01f0b9 100644
--- a/helper/include/odp/helper/odph_lineartable.h
+++ b/helper/include/odp/helper/odph_lineartable.h
@@ -20,16 +20,64 @@
 extern "C" {
 #endif
 
+/**
+ * documentation missing
+ *
+ * @param name
+ * @param capacity
+ * @param ODP_IGNORED
+ * @param value_size
+ *
+ * @return
+ */
 odph_table_t odph_linear_table_create(const char *name,
 				      uint32_t capacity,
 				      uint32_t ODP_IGNORED,
 				      uint32_t value_size);
+
+/**
+ * documentation missing
+ *
+ * @param name
+ *
+ * @return
+ */
 odph_table_t odph_linear_table_lookup(const char *name);
+
+/**
+ * documentation missing
+ *
+ * @param table
+ *
+ * @return
+ */
 int odph_linear_table_destroy(odph_table_t table);
+
+/**
+ * documentation missing
+ *
+ * @param table
+ * @param key
+ * @param value
+ *
+ * @return
+ */
 int odph_linear_put_value(odph_table_t table, void *key, void *value);
+
+/**
+ * documentation missing
+ *
+ * @param table
+ * @param key
+ * @param buffer
+ * @param buffer_size
+ *
+ * @return
+ */
 int odph_linear_get_value(odph_table_t table, void *key, void *buffer,
 			  uint32_t buffer_size);
 
+/** documentation missing */
 extern odph_table_ops_t odph_linear_table_ops;
 
 #ifdef __cplusplus