diff --git a/helper/include/odp/helper/icmp.h b/helper/include/odp/helper/icmp.h
index e25646ad..bef96784 100644
--- a/helper/include/odp/helper/icmp.h
+++ b/helper/include/odp/helper/icmp.h
@@ -32,15 +32,18 @@ typedef struct ODP_PACKED {
 	uint8_t type;		/**< message type */
 	uint8_t code;		/**< type sub-code */
 	odp_u16sum_t chksum;	/**< checksum of icmp header */
+	/** Variant mappings of ICMP fields */
 	union {
+		/** Fields used for ICMP echo msgs */
 		struct {
-			odp_u16be_t id;
-			odp_u16be_t sequence;
+			odp_u16be_t id;       /**< id */
+			odp_u16be_t sequence; /**< sequence */
 		} echo;			/**< echo datagram */
 		odp_u32be_t gateway;	/**< gateway address */
+		/** Fields used for ICMP frag msgs */
 		struct {
-			odp_u16be_t __unused;
-			odp_u16be_t mtu;
+			odp_u16be_t __unused; /**< @internal */
+			odp_u16be_t mtu;  /**< mtu */
 		} frag;			/**< path mtu discovery */
 	} un;			/**< icmp sub header */
 } odph_icmphdr_t;
diff --git a/helper/include/odp/helper/strong_types.h b/helper/include/odp/helper/strong_types.h
index 13e35a43..501d0f28 100644
--- a/helper/include/odp/helper/strong_types.h
+++ b/helper/include/odp/helper/strong_types.h
@@ -20,10 +20,11 @@
 
 /** Use strong typing for ODP types */
 #ifdef __cplusplus
+/** @internal C++ helper macro for strong typing  @param type @return */
 #define ODPH_HANDLE_T(type) struct _##type { uint8_t unused_dummy_var; } *type
 #else
 #define odph_handle_t struct { uint8_t unused_dummy_var; } *
-/** C/C++ helper macro for strong typing */
+/** @internal C helper macro for strong typing @param type @return */
 #define ODPH_HANDLE_T(type) odph_handle_t type
 #endif
 
diff --git a/helper/include/odp/helper/table.h b/helper/include/odp/helper/table.h
index b3440ef5..96c9c5fe 100644
--- a/helper/include/odp/helper/table.h
+++ b/helper/include/odp/helper/table.h
@@ -94,7 +94,7 @@ extern "C" {
 #define ODPH_TABLE_NAME_LEN      32
 
 #include <odp/helper/strong_types.h>
-/** ODP table handle */
+/** @internal ODPH table handle @return */
 typedef ODPH_HANDLE_T(odph_table_t);
 
 /**
diff --git a/helper/include/odp/helper/tcp.h b/helper/include/odp/helper/tcp.h
index fd234e58..e91b52e2 100644
--- a/helper/include/odp/helper/tcp.h
+++ b/helper/include/odp/helper/tcp.h
@@ -32,8 +32,9 @@ typedef struct ODP_PACKED {
 	odp_u16be_t dst_port; /**< Destination port */
 	odp_u32be_t seq_no;   /**< Sequence number */
 	odp_u32be_t ack_no;   /**< Acknowledgment number */
+	/** Variant maps for TCP header fields */
 	union {
-		odp_u16be_t doffset_flags;
+		odp_u16be_t doffset_flags; /**< TCP Flags aggregate */
 #if ODP_BIG_ENDIAN_BITFIELD
 		struct {
 			odp_u16be_t rsvd1:8;
@@ -42,14 +43,14 @@ typedef struct ODP_PACKED {
 		struct {
 			odp_u16be_t hl:4;    /**< Hdr len, in words */
 			odp_u16be_t rsvd3:4; /**< Reserved */
-			odp_u16be_t cwr:1;
-			odp_u16be_t ece:1;
-			odp_u16be_t urg:1;
-			odp_u16be_t ack:1;
-			odp_u16be_t psh:1;
-			odp_u16be_t rst:1;
-			odp_u16be_t syn:1;
-			odp_u16be_t fin:1;
+			odp_u16be_t cwr:1;   /**< cwr bit */
+			odp_u16be_t ece:1;   /**< ece bit */
+			odp_u16be_t urg:1;   /**< urg bit */
+			odp_u16be_t ack:1;   /**< ack bit */
+			odp_u16be_t psh:1;   /**< psh bit */
+			odp_u16be_t rst:1;   /**< rst bit */
+			odp_u16be_t syn:1;   /**< syn bit */
+			odp_u16be_t fin:1;   /**< fin bit */
 		};
 #elif ODP_LITTLE_ENDIAN_BITFIELD
 		struct {
@@ -59,14 +60,14 @@ typedef struct ODP_PACKED {
 		struct {
 			odp_u16be_t rsvd3:4; /**< Reserved */
 			odp_u16be_t hl:4;    /**< Hdr len, in words */
-			odp_u16be_t fin:1;
-			odp_u16be_t syn:1;
-			odp_u16be_t rst:1;
-			odp_u16be_t psh:1;
-			odp_u16be_t ack:1;
-			odp_u16be_t urg:1;
-			odp_u16be_t ece:1;
-			odp_u16be_t cwr:1;
+			odp_u16be_t fin:1;   /**< fin bit */
+			odp_u16be_t syn:1;   /**< syn bit */
+			odp_u16be_t rst:1;   /**< rst bit */
+			odp_u16be_t psh:1;   /**< psh bit */
+			odp_u16be_t ack:1;   /**< ack bit */
+			odp_u16be_t urg:1;   /**< urg bit */
+			odp_u16be_t ece:1;   /**< ece bit */
+			odp_u16be_t cwr:1;   /**< cwr bit */
 		};
 
 #else
diff --git a/helper/include/odp/helper/threads.h b/helper/include/odp/helper/threads.h
index 5682bab9..526f0d48 100644
--- a/helper/include/odp/helper/threads.h
+++ b/helper/include/odp/helper/threads.h
@@ -80,12 +80,15 @@ typedef struct {
 	odph_odpthread_start_args_t	start_args; /**< start arguments */
 	int				cpu;	/**< CPU ID */
 	int				last;   /**< true if last table entry */
+	/** Variant field mappings for thread/process modes */
 	union {
-		struct { /* for thread implementation */
+		/** For thread implementation */
+		struct {
 			pthread_t	thread_id; /**< Pthread ID */
 			pthread_attr_t	attr;	/**< Pthread attributes */
 		} thread;
-		struct { /* for process implementation */
+		/** For process implementation */
+		struct {
 			pid_t		pid;	/**< Process ID */
 			int		status;	/**< Process state chge status*/
 		} proc;